package about_us

import (
	"git.sxidc.com/go-framework/baize/framework/core/api/request"
)

type (
	CreateAboutUsJsonBody struct {
		CompanyTel        string `json:"companyTel" binding:"required" assign:"toField:CompanyTel"`
		OnlineShoppingTel string `json:"onlineShoppingTel" binding:"required" assign:"toField:OnlineShoppingTel"`
		AfterSaleTel      string `json:"afterSaleTel" binding:"required" assign:"toField:AfterSaleTel"`
		CompanyAddress    string `json:"companyAddress" binding:"required" assign:"toField:CompanyAddress"`
		PostCode          string `json:"postCode" binding:"required" assign:"toField:PostCode"`
		Fax               string `json:"fax" binding:"required" assign:"toField:Fax"`
		Email             string `json:"email" binding:"required" assign:"toField:Email"`
		WxMpQrCode        string `json:"wxMpQrCode" binding:"required" assign:"toField:WxMpQrCode"`
		Copyright         string `json:"copyright" binding:"required" assign:"toField:Copyright"`
		RecordNumber      string `json:"recordNumber" binding:"required" assign:"toField:RecordNumber"`
		PubRecordNumber   string `json:"pubRecordNumber" binding:"required" assign:"toField:PubRecordNumber"`
		ContactQrCode     string `json:"contactQrCode" assign:"toField:ContactQrCode"`
		Content           string `json:"content" binding:"required" assign:"toField:Content"`
		request.CreateUserIDJsonBody
		request.OperatorUserNameJsonBody
	}

	DeleteAboutUsQueryParams struct {
		request.IDQueryParam
		request.DeleteUserIDQueryParams
		request.OperatorUserNameQueryParams
	}

	UpdateAboutUsJsonBody struct {
		request.IDJsonBody
		CompanyTel        string `json:"companyTel" assign:"toField:CompanyTel"`
		OnlineShoppingTel string `json:"onlineShoppingTel" assign:"toField:OnlineShoppingTel"`
		AfterSaleTel      string `json:"afterSaleTel" assign:"toField:AfterSaleTel"`
		CompanyAddress    string `json:"companyAddress" assign:"toField:CompanyAddress"`
		PostCode          string `json:"postCode" assign:"toField:PostCode"`
		Fax               string `json:"fax" assign:"toField:Fax"`
		Email             string `json:"email" assign:"toField:Email"`
		WxMpQrCode        string `json:"wxMpQrCode" assign:"toField:WxMpQrCode"`
		Copyright         string `json:"copyright" assign:"toField:Copyright"`
		RecordNumber      string `json:"recordNumber" assign:"toField:RecordNumber"`
		PubRecordNumber   string `json:"pubRecordNumber" assign:"toField:PubRecordNumber"`
		ContactQrCode     string `json:"contactQrCode" assign:"toField:ContactQrCode"`
		Content           string `json:"content" assign:"toField:Content"`
		request.UpdateUserIDJsonBody
		request.OperatorUserNameJsonBody
	}

	GetAboutUsesQueryParams struct {
		request.BaseQueryParams
		CompanyTel        string `form:"companyTel" assign:"toField:CompanyTel"`
		OnlineShoppingTel string `form:"onlineShoppingTel" assign:"toField:OnlineShoppingTel"`
		AfterSaleTel      string `form:"afterSaleTel" assign:"toField:AfterSaleTel"`
		CompanyAddress    string `form:"companyAddress" assign:"toField:CompanyAddress"`
		PostCode          string `form:"postCode" assign:"toField:PostCode"`
		Fax               string `form:"fax" assign:"toField:Fax"`
		Email             string `form:"email" assign:"toField:Email"`
		WxMpQrCode        string `form:"wxMpQrCode" assign:"toField:WxMpQrCode"`
		Copyright         string `form:"copyright" assign:"toField:Copyright"`
		RecordNumber      string `form:"recordNumber" assign:"toField:RecordNumber"`
		PubRecordNumber   string `form:"pubRecordNumber" assign:"toField:PubRecordNumber"`
		ContactQrCode     string `form:"contactQrCode" assign:"toField:ContactQrCode"`
		Content           string `form:"content" assign:"toField:Content"`
	}

	GetAboutUsQueryParams struct {
		request.IDQueryParam
	}

	/* HAC: HTTP RELATION REQUEST PARAMS */
	/* HAC: END HTTP RELATION REQUEST PARAMS */
)
