package advertising

import (
	"git.sxidc.com/go-framework/baize/framework/core/api/request"
)

type (
	CreateAdvertisingJsonBody struct {
		Title   string `json:"title" binding:"required" assign:"toField:Title"`
		PageUrl string `json:"pageUrl" binding:"required" assign:"toField:PageUrl"`
		PicUrl  string `json:"picUrl" binding:"required" assign:"toField:PicUrl"`
		Status  int    `json:"status" binding:"required" assign:"toField:Status"`
		request.CreateUserIDJsonBody
		request.OperatorUserNameJsonBody
	}

	DeleteAdvertisingQueryParams struct {
		request.IDQueryParam
		request.DeleteUserIDQueryParams
		request.OperatorUserNameQueryParams
	}

	UpdateAdvertisingJsonBody struct {
		request.IDJsonBody
		Title   string `json:"title" assign:"toField:Title"`
		PageUrl string `json:"pageUrl" assign:"toField:PageUrl"`
		PicUrl  string `json:"picUrl" assign:"toField:PicUrl"`
		Status  int    `json:"status" assign:"toField:Status"`
		request.UpdateUserIDJsonBody
		request.OperatorUserNameJsonBody
	}

	GetAdvertisingsQueryParams struct {
		request.BaseQueryParams
		Title   string `form:"title" assign:"toField:Title"`
		PageUrl string `form:"pageUrl" assign:"toField:PageUrl"`
		PicUrl  string `form:"picUrl" assign:"toField:PicUrl"`
		Status  int    `form:"status" assign:"toField:Status"`
	}

	GetAdvertisingQueryParams struct {
		request.IDQueryParam
	}

	/* HAC: HTTP RELATION REQUEST PARAMS */
	/* HAC: END HTTP RELATION REQUEST PARAMS */
)
