package announcement_policy_info

import (
	"git.sxidc.com/go-framework/baize/framework/core/api/request"
)

type (
	CreateAnnouncementPolicyInfoJsonBody struct {
		Title           string `json:"title" binding:"required" assign:"toField:Title"`
		SecondLevelType int    `json:"secondLevelType" binding:"required" assign:"toField:SecondLevelType"`
		FirstLevelType  int    `json:"firstLevelType" assign:"toField:FirstLevelType"`
		ReleaseDate     string `json:"releaseDate" binding:"required" assign:"toField:ReleaseDate"`
		TitleImgUrl     string `json:"titleImgUrl" assign:"toField:TitleImgUrl"`
		Content         string `json:"content" assign:"toField:Content"`
		request.CreateUserIDJsonBody
		request.OperatorUserNameJsonBody
	}

	DeleteAnnouncementPolicyInfoQueryParams struct {
		request.IDQueryParam
		request.DeleteUserIDQueryParams
		request.OperatorUserNameQueryParams
	}

	UpdateAnnouncementPolicyInfoJsonBody struct {
		request.IDJsonBody
		Title           string `json:"title" assign:"toField:Title"`
		SecondLevelType int    `json:"secondLevelType" assign:"toField:SecondLevelType"`
		FirstLevelType  int    `json:"firstLevelType" assign:"toField:FirstLevelType"`
		ReleaseDate     string `json:"releaseDate" assign:"toField:ReleaseDate"`
		TitleImgUrl     string `json:"titleImgUrl" assign:"toField:TitleImgUrl"`
		Content         string `json:"content" assign:"toField:Content"`
		request.UpdateUserIDJsonBody
		request.OperatorUserNameJsonBody
	}

	GetAnnouncementPolicyInfosQueryParams struct {
		request.BaseQueryParams
		Title           string `form:"title" assign:"toField:Title"`
		SecondLevelType int    `form:"secondLevelType" assign:"toField:SecondLevelType"`
		FirstLevelType  int    `form:"firstLevelType" assign:"toField:FirstLevelType"`
		ReleaseDate     string `form:"releaseDate" assign:"toField:ReleaseDate"`
		TitleImgUrl     string `form:"titleImgUrl" assign:"toField:TitleImgUrl"`
		Content         string `form:"content" assign:"toField:Content"`
	}

	GetAnnouncementPolicyInfoQueryParams struct {
		request.IDQueryParam
	}

	/* HAC: HTTP RELATION REQUEST PARAMS */
	/* HAC: END HTTP RELATION REQUEST PARAMS */
)
