package banner

import (
	"git.sxidc.com/go-framework/baize/framework/core/domain"
	"git.sxidc.com/go-framework/baize/framework/core/domain/entity"
)

const (
	FieldTitle   = "Title"
	FieldPageUrl = "PageUrl"
	FieldPicUrl  = "PicUrl"
	FieldStatus  = "Status"
)

var fieldMap = map[string]string{
	FieldTitle:   "标题",
	FieldPageUrl: "页面路径",
	FieldPicUrl:  "图片地址",
	FieldStatus:  "状态 1隐藏,2显示",
}

var (
	ColumnTitle   = domain.ColumnName(FieldTitle)
	ColumnPageUrl = domain.ColumnName(FieldPageUrl)
	ColumnPicUrl  = domain.ColumnName(FieldPicUrl)
	ColumnStatus  = domain.ColumnName(FieldStatus)
)

type Entity struct {
	entity.Base
	Title   string `sqlmapping:"column:title;" sqlresult:"column:title;" check:"required,lte=128,when=create/update"`
	PageUrl string `sqlmapping:"column:page_url;updateClear;" sqlresult:"column:page_url;" check:"lte=256,when=create/update"`
	PicUrl  string `sqlmapping:"column:pic_url;" sqlresult:"column:pic_url;" check:"required,lte=256,when=create/update"`
	Status  int    `sqlmapping:"column:status;" sqlresult:"column:status;" check:"required,when=create/update"`
	entity.UserIDFields
	entity.OperatorUserNameField
	entity.TimeFields

	/* HAC: ENTITY RELATION FIELDS */
	/* HAC: END ENTITY RELATION FIELDS */
}

func (e *Entity) DomainCNName() string {
	return "宣传图"
}

func (e *Entity) DomainCamelName() string {
	return "Banner"
}

func (e *Entity) GetFieldMap() map[string]string {
	return fieldMap
}

/* HAC: ENTITY RELATION METHODS */
/* HAC: END ENTITY RELATION METHODS */
