package common_use_website

import (
	"git.sxidc.com/go-framework/baize/framework/core/api/request"
)

type (
	CreateCommonUseWebsiteJsonBody struct {
		Title        string `json:"title" binding:"required" assign:"toField:Title"`
		IconUrl      string `json:"iconUrl" binding:"required" assign:"toField:IconUrl"`
		AccessUrl    string `json:"accessUrl" binding:"required" assign:"toField:AccessUrl"`
		Sort         int    `json:"sort" binding:"required" assign:"toField:Sort"`
		ExternalLink int    `json:"externalLink" binding:"required" assign:"toField:ExternalLink"`
		request.CreateUserIDJsonBody
		request.OperatorUserNameJsonBody
	}

	DeleteCommonUseWebsiteQueryParams struct {
		request.IDQueryParam
		request.DeleteUserIDQueryParams
		request.OperatorUserNameQueryParams
	}

	UpdateCommonUseWebsiteJsonBody struct {
		request.IDJsonBody
		Title        string `json:"title" assign:"toField:Title"`
		IconUrl      string `json:"iconUrl" assign:"toField:IconUrl"`
		AccessUrl    string `json:"accessUrl" assign:"toField:AccessUrl"`
		Sort         int    `json:"sort" assign:"toField:Sort"`
		ExternalLink int    `json:"externalLink" assign:"toField:ExternalLink"`
		request.UpdateUserIDJsonBody
		request.OperatorUserNameJsonBody
	}

	GetCommonUseWebsitesQueryParams struct {
		request.BaseQueryParams
		Title        string `form:"title" assign:"toField:Title"`
		IconUrl      string `form:"iconUrl" assign:"toField:IconUrl"`
		AccessUrl    string `form:"accessUrl" assign:"toField:AccessUrl"`
		Sort         int    `form:"sort" assign:"toField:Sort"`
		ExternalLink int    `form:"externalLink" assign:"toField:ExternalLink"`
	}

	GetCommonUseWebsiteQueryParams struct {
		request.IDQueryParam
	}

	/* HAC: HTTP RELATION REQUEST PARAMS */
	/* HAC: END HTTP RELATION REQUEST PARAMS */
)
